#ifndef OP5_LICENSE_QUERY_H_
#define OP5_LICENSE_QUERY_H_

#include <op5/license.h>
#include <op5/license_env.h>
#include <op5/license_metadata.h>

/* For time_t */
#include <sys/time.h>

/* For bool type */
#include <stdbool.h>

struct op5lic_query_t;
struct op5lic_query_response_t;

#define OP5LIC_DEFAULT_ENTRY_POINT_NAME "query"
/* License query */
struct op5lic_query_t *op5lic_query_create(struct op5lic_t *lic,
		const char *action, struct op5lic_env_list_t *environment);
struct string_list_t * op5lic_query_response_message_list(const struct op5lic_query_response_t *);
struct metric_list_t * op5lic_query_response_metric_list(const struct op5lic_query_response_t *);
bool op5lic_query_response_allow(const struct op5lic_query_response_t *);
void op5lic_query_response_destroy(struct op5lic_query_response_t *);

void op5lic_query_destroy(struct op5lic_query_t *lq);

struct op5lic_query_response_t * op5lic_query_run(struct op5lic_query_t *lq, struct op5lic_error_t *err);
struct op5lic_query_response_t * op5lic_query_run_with_entry_point(struct op5lic_query_t *lq, struct op5lic_error_t *err, const char * entry_point);
struct op5lic_metadata_t * op5lic_query_metadata(struct op5lic_t *lic, struct op5lic_error_t *err);

#endif
